
toolbar_status = true

function store_tracks_to_table(match_pattern)
  local group, counttracks, track ,tr_name, group_name, data
  data = {}
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return end
  -- add tracks to groups
  for i = 1, counttracks do
    track = reaper.GetTrack(0,i-1)
    if track ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
      if tr_name:match(match_pattern) then
        -- extract group name
        local group_name = tr_name:match('^%u%u%u%d%d')

        ------------------------------------------------------
        --Переменные ниже отдают только true and false
        local control = false
        if tr_name:match('_Control$') then control = true end

        local IN = false
        if tr_name:match('_IN$') then IN = true end

        local Out = false
        if tr_name:match('_Out$') then Out = true end

        local preset = false
        if tr_name:match('_P%d+') then preset = true end

        local P1 = false
        if tr_name:match('_P1$') then P1 = true end
        ------------------------------------------------------

        newTrack = {}
        newTrack.name = tr_name
        newTrack.guid = reaper.GetTrackGUID(track)
        newTrack.group = group_name
        newTrack.isControl = control
        newTrack.isIN = IN
        newTrack.isOut = Out
        newTrack.isTrackPreset = preset
        newTrack.isP1Preset = P1

        table.insert(data, newTrack)
      end
    end
  end
  return data
end

function uniqueGroupsFromTracks(tracks)
  local groups = {}
  for i=1, #tracks do
    local trackObject = tracks[i]
    group = trackObject.group
    if type(groups[group]) == 'nil' then
      local newGroup = {}
      newGroup.lastPressed = 0
      newGroup.readyForAnimation = true
      groups[group] = newGroup
      -- msg('Added group: '..group)
    end
  end
  return groups
end

tracks = store_tracks_to_table('%u%u%u%d%d_')
groups = uniqueGroupsFromTracks(tracks)

------------------------------------------------------------------------------------
function timeout(towait, var, time1)
  if time1 == nil or time1 == 0 then
    time1 = reaper.time_precise()
  end

  time2 = reaper.time_precise()
  diff = time2 - time1;
  if diff < towait then
    reaper.defer(function()
      timeout(towait, var, time1)
    end)
  else
    var()
  end
end
------------------------------------------------------------------------------------

function animate_SetTrackSendUIVol(duration, track, parametr, value, tension, _startTime, _initialValue, cb)
  local currentTime, elapsedTime, totalDiff, f
  if _startTime == 0 then
    _startTime = reaper.time_precise()
    _, volumeOut, panOut = reaper.GetTrackSendUIVolPan(track, parametr)
    _initialValue = volumeOut
  end
  currentTime = reaper.time_precise()
  elapsedTime = currentTime - _startTime
  totalDiff = value - _initialValue
  x = elapsedTime / duration
  t = tension
  -- newVal = _initialValue + (totalDiff * (t*x-x) / (2*t*x-t-1))
  newVal = _initialValue + (totalDiff * ((1-(x-1)^2)^t))

  -- if t < 0 then
  --   f = -(((1-x^2)^math.abs(t))-1)
  -- else
  --   f = (1-(x-1)^2)^math.abs(t)
  -- end
  -- -- msg('x: '.. x)
  -- -- msg('t: '.. t)
  -- newVal = _initialValue + (totalDiff * (f))

  reaper.SetTrackSendUIVol(track, parametr, newVal, 0)
  if elapsedTime >= duration then
    reaper.SetTrackSendUIVol(track, parametr, value, 0)
    if cb then
      cb(track)
    end
  else
    reaper.defer(function()
      animate_SetTrackSendUIVol(duration, track, parametr, value, tension, _startTime, _initialValue, cb)
    end)
  end

end
-------------------------------------------------------------------------------
function crosfade_to_track (trackObject, track, cb)
  local fromTrackObject
  local hasFromTrack = false
  for i=1, #tracks do
    local trackObject2 = tracks[i]
    if trackObject2.group == trackObject.group
    and trackObject2.guid ~= trackObject.guid
    and trackObject2.isTrackPreset then
      local track2 = reaper.BR_GetMediaTrackByGUID(0, trackObject2.guid)
      _, volumeOut, _ = reaper.GetTrackSendUIVolPan(track2, 0)
      if volumeOut ~= 0 then
        -- reaper.SetTrackSendUIVol(track, 0, 0, 0)
        -- msg('OFF: '..trackObject2.name)
        duration_to = reaper.TrackFX_GetParam(track, 0, 8)
        duration_from = reaper.TrackFX_GetParam(track, 0, 10)
        tension_to = reaper.TrackFX_GetParam(track, 0, 7)
        tension_from = reaper.TrackFX_GetParam(track, 0, 9)
        animate_SetTrackSendUIVol(duration_from, track2, 0, 0, tension_from, 0, 0, cb)
        hasFromTrack = true
        fromTrackObject = trackObject2
      end
    end
  end
  local acb = nil
  if hasFromTrack ~= true then
    acb = cb
  end

  animate_SetTrackSendUIVol(duration_to, track, 0, 1, tension_to, 0, 0, function(fromTrack)
    if acb then
      acb()
    end
  end)

  return fromTrackObject
end
-------------------------------------------------------------------------------
function groupIsReadyForAnimation (group)
  if groups[group].readyForAnimation ~= true then
    return false
  end

  for i=1, #tracks do
    local trackObject2 = tracks[i]
    if trackObject2.group == group
    and trackObject2.isTrackPreset then
      local track2 = reaper.BR_GetMediaTrackByGUID(0, trackObject2.guid)
      _, volumeOut, _ = reaper.GetTrackSendUIVolPan(track2, 0)
      if volumeOut >= 0.000001 and volumeOut <= 0.99999 then
        -- msg('OFF: '.. trackObject2.name)
        return false
      end
    end
  end

  return true
end
-------------------------------------------------------------------------------
function turnFX_On_Off (toTrack,on_off)
  fx_count = reaper.TrackFX_GetCount(toTrack) - 1
  FXParamCount = (reaper.TrackFX_GetNumParams(toTrack, 0)) - 2
  for i=1, fx_count do
    local z = i + 12
    OnFX = reaper.TrackFX_GetParam(toTrack, 0, z)
    -- msg('FXParam_Count: '.. z ..' - ' .. OnFX)
    if OnFX == 1 then
      reaper.TrackFX_SetEnabled(toTrack, i, on_off)
    end
  end
end

function turnFX_On_Off_Start (toTrack,on_off)
  fx_count = reaper.TrackFX_GetCount(toTrack) - 1
  for i=1, fx_count do
    reaper.TrackFX_SetEnabled(toTrack, i, on_off)
  end
end

function showMixerForOnly(toTrackObject, fromTrackObject)
  for i=1, #tracks do
    local trackObject = tracks[i]
    local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
    local _, tr_name = reaper.GetSetMediaTrackInfo_String(track, 'P_NAME', '', false)
    local gr_nm = string.sub(tr_name, 1, 5)
    if trackObject.isTrackPreset and (toTrackObject.group == trackObject.group or fromTrackObject.group == trackObject.group) then
      if trackObject.guid == toTrackObject.guid or trackObject.guid == fromTrackObject.guid then
        reaper.SetMediaTrackInfo_Value(track, 'B_SHOWINMIXER', 1)
      else
        reaper.SetMediaTrackInfo_Value(track, 'B_SHOWINMIXER', 0)
      end
    end
  end
  reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
end
---MAIN------------------------------------------------------------------------
function Main ()
  -------------------------------------------------------------------------------------------------------
  -- local proj_change = false
  -- function Proj_Change()
  --   local cur_cnt = reaper.GetProjectStateChangeCount(0)
  --   if not Proj_Change_cnt or cur_cnt ~= Proj_Change_cnt then
  --     Proj_Change_cnt = cur_cnt
  --     return true
  --   end
  -- end
  -- proj_change = Proj_Change()
  -------------------------------------------------------------------------------------------------------

  for i=1, #tracks do
    local trackObject = tracks[i]
    if trackObject.isTrackPreset then
      local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
      if reaper.TrackFX_GetParam(track, 0, 1) == 1 then
        -- msg('PRESSED: '..trackObject.name)
        GUID_N = trackObject.guid
        groups[trackObject.group].lastPressed = i
        reaper.TrackFX_SetParam(track, 0, 1, 0) --сбрасывает STATE MIDI в OFF
      end
    end
  end

  for group,groupO in pairs(groups) do
    local lastPressed = groupO.lastPressed
    if lastPressed > 0 then
      if groupIsReadyForAnimation (group) then
        local toTrackObject = tracks[lastPressed]
        local toTrack = reaper.BR_GetMediaTrackByGUID(0, toTrackObject.guid)
        for i=1,#tracks do
          local trackObject = tracks[i]
          if trackObject.isTrackPreset then
            local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
          end
        end

        _, volumeOut, _ = reaper.GetTrackSendUIVolPan(toTrack, 0)
        if volumeOut ~= 1 then

          groups[group].readyForAnimation = false
          turnFX_On_Off (toTrack, 1)
          reaper.TrackFX_SetParam(toTrack, 0, 0, 0) --Ставит громкость на треке куда идём в 0dB
          reaper.TrackFX_SetParam(toTrack, 0, 3, 1)

          local fromTrackObject = crosfade_to_track (toTrackObject, toTrack, function (fromTrack)
            if fromTrack then
              reaper.TrackFX_SetParam(fromTrack, 0, 3, 0)
            end
            timeout(0.2, function()
              if fromTrack then
                reaper.TrackFX_SetParam(fromTrack, 0, 0, -80)
                turnFX_On_Off (fromTrack, 0)
                reaper.TrackFX_SetParam(toTrack, 0, 1, 0) --Нужно может быть для регистрации ласт тач плага
              end
              groups[group].readyForAnimation = true
            end)
          end)

          if HideTrack == true then
            showMixerForOnly(toTrackObject, fromTrackObject)
          end

          groups[group].lastPressed = 0
        end

      end
    end
  end
  if char ~= -1 then reaper.defer(Main) end -- Следит за GUI скрипта
end
-------------------------------------------------------------------------------
--- START----------------------------------------------------------------------
function Start ()
  for i=1, #tracks do
    local trackObject = tracks[i]

    if trackObject.isOut then
      local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
      reaper.SetMediaTrackInfo_Value(track,'B_MUTE', 1)
      timeout(1.8, function()
        reaper.SetMediaTrackInfo_Value(track,'B_MUTE', 0)
        YES = true -- нужно для того. чтобы не сбрасывались запомненные байпас-андбайпас на стартовом треке
      end)

    end

    if trackObject.isTrackPreset then
      local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
      turnFX_On_Off_Start (track,0)
      timeout(0.5, function()
        turnFX_On_Off_Start (track,1)
      end)
      timeout(1, function()
        turnFX_On_Off_Start (track,0)
      end)
      if trackObject.isP1Preset then
        timeout(1.5, function()
          turnFX_On_Off (track,1)
          reaper.SetTrackSendUIVol(track, 0, 1, 0)
          reaper.TrackFX_SetParam(track, 0, 0, 0)
          reaper.TrackFX_SetParam(track, 0, 3, 1)
          timeout(0.5, function()
            reaper.TrackFX_SetParam(track, 0, 1, 1)
            reaper.SetMediaTrackInfo_Value(track, 'B_SHOWINMIXER', 1)
            reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
          end)
        end)
      else
        timeout(1.5, function()
          reaper.SetTrackSendUIVol(track, 0, 0, 0)
          reaper.TrackFX_SetParam(track, 0, 0, -80)
          reaper.TrackFX_SetParam(track, 0, 3, 0)
        end)
      end
    end

    if trackObject.isControl or trackObject.isIN then
      local track = reaper.BR_GetMediaTrackByGUID(0, trackObject.guid)
      timeout(0.05, function()
        reaper.CSurf_OnRecArmChange(track, 0)
      end)
      -- timeout(0.5, function()
      --   reaper.CSurf_OnRecArmChange(track, 1) -- откоментить для Live проекта
      -- end)
    end
  end
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- Set ToolBar Button ON
-- function SetButtonON()
--   is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
--   state = reaper.GetToggleCommandStateEx( sec, cmd )
--   reaper.SetToggleCommandState( sec, cmd, 1 ) -- Set ON
--   reaper.RefreshToolbar2( sec, cmd )
-- end
-- --
-- -- Set ToolBar Button OFF
-- function SetButtonOFF()
--   is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
--   state = reaper.GetToggleCommandStateEx( sec, cmd )
--   reaper.SetToggleCommandState( sec, cmd, 0 ) -- Set OFF
--   reaper.RefreshToolbar2( sec, cmd )
-- end

--------------------------------------------------------------------------------

-- require "WahWah_GTR01"
--
-- require "WahWah_GTR02"

--------------------------------------------------------------------------------


-- -- RUN
-- SetButtonON()
Start ()
Main ()

-- reaper.atexit( SetButtonOFF )
