---------------------------------------------------------------------------------------------------------
local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
---------------------------------------------------------------------------------------------------------
reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWS_SAVESEL"), 0) --SWS: Save current track selection

local track_to_track = reaper.BR_GetMediaTrackByGUID(0, Guid_to_track)
_, tr_name = reaper.GetSetMediaTrackInfo_String(track_to_track, 'P_NAME', '', false)

item_name_n_cursor, cursor_position_n_left, cursor_position_next_left_new, cursor_position_n_right = nil
-- Назначение параметров вставляемого на трэк айтема ----------------------------------------------------
inst_name = string.sub(tr_name,1,5)
preset_namber = string.sub(tr_name,8)
lenghth_item = 4 -- Длинна айтема в секундах
if tr_name:match("KEY01_") then
  y_pos = 0.0000000000
  msgChannel = 9 -- миди канал 10
elseif tr_name:match("GTR01_") then
  y_pos = 0.3300000000
  msgChannel = 10 -- миди канал 11
elseif tr_name:match("GTR02_") then
  y_pos = 0.6600000000
  msgChannel = 11 -- миди канал 12
elseif tr_name:match("BAS01_") then
  y_pos = 1.0000000000
  msgChannel = 12 -- миди канал 13
end
preset_name = "P"..preset_namber
match_pattern = inst_name.."_Control"
item_name = preset_name.." - "..inst_name
text_name = inst_name..":              "..preset_name
---------------------------------------------------------------------------------------------------------
tm = reaper.GetCursorPosition() -- запоминаем позицию курсора
tm_end = tm + lenghth_item -- Задаём дефолтную длину айтема

--- Ищем _Control трэк той группы на трек-пресет которой нажали------------------------------------------
counttracks = reaper.CountTracks(0)
if counttracks == nil then return end
local track_control = nil
local foundTrack = nil
for i=1, counttracks do
  local foundTrack = reaper.GetTrack(0, i-1)
  if foundTrack then
    _, tr_name = reaper.GetSetMediaTrackInfo_String(foundTrack, 'P_NAME', 'text_name', false)
    if tr_name:match(match_pattern) then
      reaper.SetOnlyTrackSelected(foundTrack) -- Выделяем только тот трек, айтемы которого нас интересуют
      track_control = foundTrack
    end
  end
end
---------------------------------------------------------------------------------------------------------

function ReadNextItem ()
  --- Считываем данные со следующего от курсора айтема---------------------------------------------------
  if item_name_n_cursor == nil and cursor_position_n_left == nil and cursor_position_n_right == nil then
    reaper.Main_OnCommand(40417,0) -- Select and move to next item
    -- (перемещает курсор в начало следующего айтема)
    local item = reaper.GetSelectedMediaItem(0, 0)
    if item then
      take = reaper.GetActiveTake(item)
      -- ret, item_name_n_cursor = reaper.TakeFX_GetFXName(take, 0, "")
      item_name_n_cursor = reaper.GetTakeName( take )
      cursor_position_n_left = reaper.GetCursorPosition() -- Начало следующего айтема
      reaper.Main_OnCommand(40319,0) -- Move cursor to right edge select item
      -- (перемещает курсор в конец следующего айтема)
      cursor_position_n_right = reaper.GetCursorPosition() -- Конец следющего айтема
      reaper.Main_OnCommand(40289,0) -- Unselect all item
      -- msg(item_name_next_cursor.." : "..cursor_position_next_left.." : "..cursor_position_next_right)
    end
    reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
  end
  return item_name_n_cursor, cursor_position_n_left, cursor_position_n_right
end


function ReadPreviousItem ()
  --- Считываем данные с предидущего от курсора айтема---------------------------------------------------
  local item_name_previous_cursor, cursor_position_previous_left, cursor_position_previous_right
  reaper.Main_OnCommand(40416,0) -- Select and move to previous item
  -- (перемещает курсор в начало предидущего айтема)
  local item = reaper.GetSelectedMediaItem(0, 0)
  if item then
    take = reaper.GetActiveTake(item)
    -- ret, item_name_previous_cursor = reaper.TakeFX_GetFXName(take, 0, "")
    item_name_previous_cursor = reaper.GetTakeName( take )
    cursor_position_previous_left = reaper.GetCursorPosition() -- Начало следующего айтема
    reaper.Main_OnCommand(40319,0) -- Move cursor to right edge select item
    -- (перемещает курсор в конец следующего айтема)
    cursor_position_previous_right = reaper.GetCursorPosition() -- Конец следющего айтема
    reaper.Main_OnCommand(40289,0) -- Unselect all item
  end
  reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
  return item_name_previous_cursor, cursor_position_previous_left, cursor_position_previous_right
end

---------------------------------------------------------------------------------------------------------
--- Определяем есть ли под курсором айтем, и если есть - удаляем его, либо режем и удаляем правый.
-- Уравниваем состояние с и без айтема под курсором.
reaper.SetEditCurPos(tm + 0.1, true, true) -- Сдвигаем курсор чуть в право, чтоб не задеть предидущий айтем,
-- если курсор стоит на стыке айтемов
reaper.Main_OnCommand(reaper.NamedCommandLookup("_XENAKIOS_SELITEMSUNDEDCURSELTX"), 0)
item = reaper.GetSelectedMediaItem(0, 0)
if item then
  take = reaper.GetActiveTake(item)
  -- ret, item_name_under_cursor = reaper.TakeFX_GetFXName(take, 0, "") -- Получаем имя айтема под курсором
  -- (если он есть)
  item_name_under_cursor = reaper.GetTakeName( take )
end
reaper.SetEditCurPos(tm, true, true) -- Возвращаем курсор в исходную позицию

if item ~= nil then
  if item_name == item_name_under_cursor then
    item = reaper.GetSelectedMediaItem(0, 0)
    reaper.DeleteTrackMediaItem(track_control, item)
    reaper.Main_OnCommand(40416,0) -- Select and move to previous item
    -- (перемещает курсор в начало предидущего айтема)
    if tm == reaper.GetCursorPosition() then
      tm = 0 -- запоминаем новую позицию курсора - Home
      tm_end = tm + lenghth_item -- Задаём новую дефолтную длину айтема
    else
      reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
      reaper.Main_OnCommand(41311,0) -- Trim right edge of item to edit cursor
    end
  else
    reaper.Main_OnCommand(40759,0) -- Split items and select right
    item = reaper.GetSelectedMediaItem(0, 0)
    reaper.DeleteTrackMediaItem(track_control, item)
    local item_name_next_cursor, cursor_position_next_left, cursor_position_next_right = ReadNextItem ()
    local item_name_previous_cursor, cursor_position_previous_left, cursor_position_previous_right = ReadPreviousItem ()
    if item_name == item_name_next_cursor then
      reaper.Main_OnCommand(40417,0) -- Select and move to next item
      -- (перемещает курсор в начало следующего айтема)
      item = reaper.GetSelectedMediaItem(0, 0)
      reaper.DeleteTrackMediaItem(track_control, item)
      cursor_position_next_left_new = cursor_position_next_right
    elseif item_name == item_name_previous_cursor then
      reaper.Main_OnCommand(40416,0) -- Select and move to previous item
      item = reaper.GetSelectedMediaItem(0, 0)
      reaper.DeleteTrackMediaItem(track_control, item)
      reaper.Main_OnCommand(40416,0) -- Select and move to previous item
      reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
      reaper.Main_OnCommand(41311,0) -- Trim right edge of item to edit cursor
    end
  end
else
  local item_name_next_cursor, cursor_position_next_left, cursor_position_next_right = ReadNextItem ()
  local item_name_previous_cursor, cursor_position_previous_left, cursor_position_previous_right = ReadPreviousItem ()

  if item_name == item_name_next_cursor then
    reaper.Main_OnCommand(40417,0) -- Select and move to next item
    -- (перемещает курсор в начало следующего айтема)
    item = reaper.GetSelectedMediaItem(0, 0)
    reaper.DeleteTrackMediaItem(track_control, item)
    reaper.Main_OnCommand(40416,0) -- Select and move to previous item
    reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
    reaper.Main_OnCommand(41311,0) -- Trim right edge of item to edit cursor
    cursor_position_next_left_new = cursor_position_next_right

  elseif item_name == item_name_previous_cursor then
    reaper.Main_OnCommand(40416,0) -- Select and move to previous item
    item = reaper.GetSelectedMediaItem(0, 0)
    reaper.DeleteTrackMediaItem(track_control, item)
    reaper.Main_OnCommand(40416,0) -- Select and move to previous item
    reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
    reaper.Main_OnCommand(41311,0) -- Trim right edge of item to edit cursor
  else
    reaper.Main_OnCommand(40416,0) -- Select and move to previous item
    reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
    reaper.Main_OnCommand(41311,0) -- Trim right edge of item to edit cursor
  end
end
reaper.SetEditCurPos(tm,true,true) -- Возвращает курсор на позицию в которой курсор был изначально
reaper.Main_OnCommand(40289,0) -- Unselect all item
---------------------------------------------------------------------------------------------------------
function Chank_wright (item) -- Запись в чанк FX-а
  local ret,Chunk,TAKEFX,FXID
  -- Item Chunk -----------------------------------------------------------------------------------------
  ret, Chunk  = reaper.GetItemStateChunk(item,"",false)
  if Chunk:find("TAKEFX") then  return end
  -- New Chunk  -----------------------------------------------------------------------------------------
  Chunk = Chunk:sub(1,-3)
  FXID =  reaper.genGuid("") -- Gen FXID
  -- Video_processor ------------------------------------------------------------------------------------
  TAKEFX =
  [[<TAKEFX
  WNDRECT 289 343 902 630
  SHOW 0
  LASTSEL 0
  DOCKED 0
  BYPASS 0 0 0
  <VIDEO_EFFECT "Video processor" "]].. item_name..[["
  <CODE
  |// text overlay
  |text="]]..text_name..[[";
  |font="Arial";
  |
  |//@param1:size 'text height' 0.05 0.01 0.2 0.1 0.01
  |//@param2:ypos 'y position' 0.95 0 1 0.5 0.01
  |//@param3:xpos 'x position' 0 0 1 0.5 0.01
  |//@param4:border 'border' 0 0 1 0.5 0.01
  |//@param5:fgc 'text bright' 1.0 0 1 0.5 0.01
  |//@param6:fga 'text alpha' 1.0 0 1 0.5 0.01
  |//@param7:bgc 'bg bright' 0.75 0 1 0.5 0.01
  |//@param8:bga 'bg alpha' 0.5 0 1 0.5 0.01
  |
  |gfx_blit(0,1);
  |gfx_setfont(size*project_h,font);
  |gfx_str_measure(text,txtw,txth);
  |yt = (project_h- txth*(1+border*2))*ypos;
  |gfx_set(bgc,bgc,bgc,bga);
  |gfx_fillrect(0, yt, project_w, txth*(1+border*2));
  |gfx_set(fgc,fgc,fgc,fga);
  |gfx_str_draw(text,xpos * (project_w-txtw),yt+txth*border);
  >
  CODEPARM 0.2000000000 ]]..y_pos..[[ 0.4000000000 0.0000000000 1.0000000000 1.0000000000 0.5300000000 0.1700000000 0.0000000000 0.0000000000 1.0000000000 0.0000000000 0.0000000000 0.0000000000 0.0000000000 0.0000000000
  >
  FLOATPOS 0 0 0 0
  FXID ]]..FXID.. -- Insert FXID
  [[WAK 0
  >
  >]]
  -------------------------------------------------------------------------------------------------------
  Chunk = Chunk..TAKEFX

  reaper.SetItemStateChunk(item , Chunk, true)
  reaper.UpdateItemInProject(item)
  reaper.UpdateArrange()
end
---------------------------------------------------------------------------------------------------------
function InsertItem ()

  local item_name_next_cursor, cursor_position_next_left, cursor_position_next_right =  ReadNextItem ()

  if cursor_position_next_left_new then
    cursor_position_next_left = cursor_position_next_left_new
  end


  if item_name_next_cursor then
    item = reaper.CreateNewMIDIItemInProj(track_control, tm, cursor_position_next_left)
  else
    item = reaper.CreateNewMIDIItemInProj(track_control, tm, tm_end)
  end

  reaper.SetMediaItemSelected(item, 1)
  take = reaper.GetActiveTake(item)
  reaper.SetMediaItemInfo_Value(item, "B_LOOPSRC", 0)

  reaper.GetSetMediaItemTakeInfo_String(take, "P_NAME", item_name, true)

  if tonumber(preset_namber) == 1 then
    newvalue = 16842687.0
  elseif tonumber(preset_namber) == 2 then
    newvalue = 16842496.0
  elseif tonumber(preset_namber) == 3 then
    newvalue = 33537792.0
  elseif tonumber(preset_namber) == 4 then
    newvalue = 33497088.0
  elseif tonumber(preset_namber) == 5 then
    newvalue = 33489017.0
  elseif tonumber(preset_namber) == 6 then
    newvalue = 33095935.0
  else
    newvalue = 16777471.0
  end

  reaper.SetMediaItemInfo_Value( item, "I_CUSTOMCOLOR", newvalue)

  ppqpos = reaper.MIDI_GetPPQPosFromProjTime(take , tm + 0.01)
  sel , muted = false, false
  msgType, msg2, msg3 = 176, 111, preset_namber -- 172 = СC, 111 контролер, val
  reaper.MIDI_InsertCC( take , sel , muted, ppqpos,  msgType, msgChannel, msg2, msg3)
  reaper.SetMediaItemSelected(item, 1)

  reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWS_RESTORESEL"), 0) -- SWS: Restore saved track selection
  reaper.Main_OnCommand(reaper.NamedCommandLookup("_S&M_WNMAIN"), 0)
  -- Chank_wright (item)
end

InsertItem ()
reaper.Main_OnCommand(40289,0) -- Unselect all item
-- reaper.Main_OnCommand(40297,0) -- Unselect all track_control
