--------------------------------------------------------------------------------
local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
--------------------------------------------------------------------------------

Utils = {}

Utils.msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end

Utils.getTracksByPattern = function(pattern, filter)
  local counttracks, tr ,tr_name
  local tracksX = {}
  local tracksNO = {}
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return tracksX end
  for i=1, counttracks do
    tr = reaper.GetTrack(0,i-1)
    if tr ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(tr, 'P_NAME', '', false)
      if tr_name:match(pattern) then
        if filter ~= nil then
          if filter(tr, tr_name) == true then
            table.insert(tracksX, tr)
          end
        else
          table.insert(tracksX, tr)
        end
      else
        if filter ~= nil then
          if filter(tr, tr_name) == true then
            table.insert(tracksNO, tr)
          end
        else
          table.insert(tracksNO, tr)
        end
      end
    end
  end
  return tracksX, tracksNO
end

Utils.getTracksByOnlyPattern = function(pattern)
  local counttracks, tr ,tr_name
  local tracks_patern = {}
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return tracks_patern end
  for i=1, counttracks do
    tr = reaper.GetTrack(0,i-1)
    if tr ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(tr, 'P_NAME', '', false)
      for j=1, #pattern do
        if tr_name:match(pattern[j]) then
          local new = true
          for k=1, #tracks_patern do
            if tr == tracks_patern[k] then
              new = false
              break
            end
          end
          if new == true then table.insert(tracks_patern, tr) end
        end
      end
    end
  end
  return tracks_patern
end

Utils.getTracksWithFXByPattern = function(pattern)
  local counttracks, tr ,tr_name
  local tracksWithFX = {}
  counttracks = reaper.CountTracks(0)
  if counttracks == nil then return tracksX end
  for i=1, counttracks do
    tr = reaper.GetTrack(0,i-1)
    if tr ~= nil then
      _, tr_name = reaper.GetSetMediaTrackInfo_String(tr, 'P_NAME', '', false)
      if tr_name:match(pattern) then
        CountFX = reaper.TrackFX_GetCount( tr )
        string = tr_name
        for i=1, CountFX do
           retval, FX_Name = reaper.TrackFX_GetFXName( tr, i-1, "" )
           string = string.." | "..FX_Name
        end
        table.insert(tracksWithFX, string)
      end
    end
  end
  return tracksWithFX
end


Utils.writeStringToFile = function(filename, string)
  file = io.open(filename, "w")
  io.output(file)
  io.write(string)
  io.close(file)
end

Utils.readStringFromFile = function(filename)
  file = io.open(filename, "r")
  local data_s = file:read("*a")
  file:close()
  return data_s
end

Utils.explode = function (d,p)
  local t, ll
  t={}
  ll=0
  if(#p == 1) then return {p} end
  while true do
    l=string.find(p,d,ll,true) -- find the next d in the string
    if l~=nil then -- if "not not" found then..
      table.insert(t, string.sub(p,ll,l-1)) -- Save it in our array.
      ll=l+1 -- save just after where we found it for searching next time.
    else
      table.insert(t, string.sub(p,ll)) -- Save what's left in our array.
      break -- Break at end, as it should be, according to the lua manual.
    end
  end
  return t
end

Utils.join = function(delimiter, list)
  if list == nil then return "" end
  local len = #list
  if len == 0 then
    return ""
  end
  local fString = ""
  if list[1] ~= nil then fString = list[1]:__tostring() end
  local string = ""..fString
  for i = 2, len do
    local val = list[i]
    local str = ""
    if val ~= nil then str = val:__tostring() end
    string = string .. delimiter .. str
  end
  return string
end

Utils.deleteSubstringsFromString = function (substrings, string)
  for i=1,#substrings do
    string = string.gsub(string, substrings[i], "")
  end
  return string
end

Utils.replaceSubstringsInString = function (substrings, string)
  for i=1,#substrings do
    local substring = substrings[i]
    local p = 0
    string = string.gsub(string, substring.search, function(v)
      p = p+1
      if (substring.skip ~= nil and p < substring.skip+1) then
        return v
      else
        return substring.replace
      end
    end)
  end
  return string
end

Utils.scandir = function (dir, pattern)
  local table_f = {}
  for f in io.popen("dir \""..dir..pattern.."\" /s /B" ):lines() do
    table.insert(table_f, f)
  end
  return table_f
end
